aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--src/libexpr/flake/flakeref.cc39
-rw-r--r--tests/flake-searching.sh14
2 files changed, 32 insertions, 21 deletions
diff --git a/src/libexpr/flake/flakeref.cc b/src/libexpr/flake/flakeref.cc
index 06f8511b6..930ed9ccd 100644
--- a/src/libexpr/flake/flakeref.cc
+++ b/src/libexpr/flake/flakeref.cc
@@ -122,27 +122,28 @@ std::pair<FlakeRef, std::string> parseFlakeRefWithFragment(
if (isFlake) {
- if (!allowMissing && !pathExists(path + "/flake.nix")){
- notice("path '%s' does not contain a 'flake.nix', searching up",path);
-
- // Save device to detect filesystem boundary
- dev_t device = lstat(path).st_dev;
- bool found = false;
- while (path != "/") {
- if (pathExists(path + "/flake.nix")) {
- found = true;
- break;
- } else if (pathExists(path + "/.git"))
- throw Error("unable to find a flake before encountering git boundary at '%s'", path);
- else {
- if (lstat(path).st_dev != device)
- throw Error("path '%s' is not part of a flake (neither it nor its parent directories contain a 'flake.nix' file)", origPath);
+ if (!allowMissing && !pathExists(path + "/flake.nix")){
+ notice("path '%s' does not contain a 'flake.nix', searching up",path);
+
+ // Save device to detect filesystem boundary
+ dev_t device = lstat(path).st_dev;
+ bool found = false;
+ while (path != "/") {
+ if (pathExists(path + "/flake.nix")) {
+ found = true;
+ break;
+ } else if (pathExists(path + "/.git"))
+ throw Error("path '%s' is not part of a flake (neither it nor its parent directories contain a 'flake.nix' file)", path);
+ else {
+ if (lstat(path).st_dev != device)
+ throw Error("unable to find a flake before encountering filesystem boundary at '%s'", path);
+ }
+ path = dirOf(path);
}
- path = dirOf(path);
+ if (!found)
+ throw BadURL("could not find a flake.nix file");
}
- if (!found)
- throw BadURL("could not find a flake.nix file");
- }
+
if (!S_ISDIR(lstat(path).st_mode))
throw BadURL("path '%s' is not a flake (because it's not a directory)", path);
diff --git a/tests/flake-searching.sh b/tests/flake-searching.sh
index 82ae66894..7c2041ce1 100644
--- a/tests/flake-searching.sh
+++ b/tests/flake-searching.sh
@@ -4,8 +4,11 @@ clearStore
cp ./simple.nix ./simple.builder.sh ./config.nix $TEST_HOME
cd $TEST_HOME
+mkdir -p foo/subdir
+echo '{ outputs = _: {}; }' > foo/flake.nix
cat <<EOF > flake.nix
{
+ inputs.foo.url = "$PWD/foo";
outputs = a: {
defaultPackage.$system = import ./simple.nix;
packages.$system.test = import ./simple.nix;
@@ -13,12 +16,19 @@ cat <<EOF > flake.nix
}
EOF
mkdir subdir
-cd subdir
+pushd subdir
-for i in "" . "$PWD" .# .#test; do
+for i in "" . .# .#test ../subdir ../subdir#test "$PWD"; do
nix build $i || fail "flake should be found by searching up directories"
done
for i in "path:$PWD"; do
! nix build $i || fail "flake should not search up directories when using 'path:'"
done
+
+popd
+
+nix build --override-input foo . || fail "flake should search up directories when not an installable"
+
+sed "s,$PWD/foo,$PWD/foo/subdir,g" -i flake.nix
+! nix build || fail "flake should not search upwards when part of inputs"